diff -r f40675df5d4c trytond/modules/account/configuration.py
--- a/trytond/modules/account/configuration.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/configuration.py	Mon Sep 24 20:36:38 2012 +0200
@@ -5,12 +5,12 @@
 from trytond.transaction import Transaction
 from trytond.pyson import Eval
 
+__all__ = ['Configuration']
+
 
 class Configuration(ModelSingleton, ModelSQL, ModelView):
     'Account Configuration'
-    _name = 'account.configuration'
-    _description = __doc__
-
+    __name__ = 'account.configuration'
     default_account_receivable = fields.Function(fields.Many2One(
         'account.account', 'Default Account Receivable',
         domain=[
@@ -26,46 +26,44 @@
                 ]),
         'get_account', setter='set_account')
 
-    def get_account(self, ids, name):
-        property_obj = Pool().get('ir.property')
-        model_field_obj = Pool().get('ir.model.field')
+    def get_account(self, name):
+        pool = Pool()
+        Property = pool.get('ir.property')
+        ModelField = pool.get('ir.model.field')
         company_id = Transaction().context.get('company')
-        account_field_id, = model_field_obj.search([
+        account_field, = ModelField.search([
             ('model.model', '=', 'party.party'),
             ('name', '=', name[8:]),
             ], limit=1)
-        property_ids = property_obj.search([
-            ('field', '=', account_field_id),
+        properties = Property.search([
+            ('field', '=', account_field.id),
             ('res', '=', None),
             ('company', '=', company_id),
             ], limit=1)
-        if property_ids:
-            prop = property_obj.browse(property_ids[0])
-            value = int(prop.value.split(',')[1])
-        else:
-            value = None
-        return dict((x, value) for x in ids)
+        if properties:
+            prop, = properties
+            return prop.value.id
 
-    def set_account(self, ids, name, value):
-        property_obj = Pool().get('ir.property')
-        model_field_obj = Pool().get('ir.model.field')
+    @classmethod
+    def set_account(cls, configurations, name, value):
+        pool = Pool()
+        Property = pool.get('ir.property')
+        ModelField = pool.get('ir.model.field')
         company_id = Transaction().context.get('company')
-        account_field_id, = model_field_obj.search([
+        account_field, = ModelField.search([
             ('model.model', '=', 'party.party'),
             ('name', '=', name[8:]),
             ], limit=1)
-        property_ids = property_obj.search([
-            ('field', '=', account_field_id),
+        properties = Property.search([
+            ('field', '=', account_field.id),
             ('res', '=', None),
             ('company', '=', company_id),
             ])
         with Transaction().set_user(0):
-            property_obj.delete(property_ids)
+            Property.delete(properties)
             if value:
-                property_obj.create({
-                    'field': account_field_id,
+                Property.create({
+                    'field': account_field.id,
                     'value': 'account.account,%s' % value,
                     'company': company_id,
                     })
-
-Configuration()
diff -r f40675df5d4c trytond/modules/account/fiscalyear.py
--- a/trytond/modules/account/fiscalyear.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/fiscalyear.py	Mon Sep 24 20:36:38 2012 +0200
@@ -8,6 +8,8 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['FiscalYear', 'CloseFiscalYearStart', 'CloseFiscalYear']
+
 STATES = {
     'readonly': Eval('state') == 'close',
 }
@@ -16,9 +18,7 @@
 
 class FiscalYear(ModelSQL, ModelView):
     'Fiscal Year'
-    _name = 'account.fiscalyear'
-    _description = __doc__
-
+    __name__ = 'account.fiscalyear'
     name = fields.Char('Name', size=None, required=True, depends=DEPENDS)
     code = fields.Char('Code', size=None)
     start_date = fields.Date('Starting Date', required=True, states=STATES,
@@ -48,14 +48,15 @@
                 Eval('context', {}).get('company', 0)),
             ], select=True)
 
-    def __init__(self):
-        super(FiscalYear, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(FiscalYear, cls).__setup__()
+        cls._constraints += [
             ('check_dates', 'fiscalyear_overlaps'),
             ('check_post_move_sequence', 'different_post_move_sequence'),
         ]
-        self._order.insert(0, ('start_date', 'ASC'))
-        self._error_messages.update({
+        cls._order.insert(0, ('start_date', 'ASC'))
+        cls._error_messages.update({
             'change_post_move_sequence': 'You can not change ' \
                     'the post move sequence',
             'no_fiscalyear_date': 'No fiscal year defined for this date!',
@@ -70,7 +71,7 @@
             'reopen_error': 'You can not reopen a fiscal year until ' \
                     'there is more recent fiscal year closed!',
             })
-        self._buttons.update({
+        cls._buttons.update({
                 'create_period': {
                     'invisible': ((Eval('state') != 'open')
                         | Eval('periods', [0])),
@@ -87,70 +88,69 @@
                     },
                 })
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'open'
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def check_dates(self, ids):
+    def check_dates(self):
         cursor = Transaction().cursor
-        for fiscalyear in self.browse(ids):
-            cursor.execute('SELECT id ' \
-                    'FROM ' + self._table + ' ' \
-                    'WHERE ((start_date <= %s AND end_date >= %s) ' \
-                            'OR (start_date <= %s AND end_date >= %s) ' \
-                            'OR (start_date >= %s AND end_date <= %s)) ' \
-                        'AND company = %s ' \
-                        'AND id != %s',
-                    (fiscalyear.start_date, fiscalyear.start_date,
-                        fiscalyear.end_date, fiscalyear.end_date,
-                        fiscalyear.start_date, fiscalyear.end_date,
-                        fiscalyear.company.id, fiscalyear.id))
-            if cursor.fetchone():
-                return False
+        cursor.execute('SELECT id ' \
+                'FROM ' + self._table + ' ' \
+                'WHERE ((start_date <= %s AND end_date >= %s) ' \
+                        'OR (start_date <= %s AND end_date >= %s) ' \
+                        'OR (start_date >= %s AND end_date <= %s)) ' \
+                    'AND company = %s ' \
+                    'AND id != %s',
+                (self.start_date, self.start_date,
+                    self.end_date, self.end_date,
+                    self.start_date, self.end_date,
+                    self.company.id, self.id))
+        if cursor.fetchone():
+            return False
         return True
 
-    def check_post_move_sequence(self, ids):
-        for fiscalyear in self.browse(ids):
-            if self.search([
-                ('post_move_sequence', '=', fiscalyear.post_move_sequence.id),
-                ('id', '!=', fiscalyear.id),
-                ]):
-                return False
+    def check_post_move_sequence(self):
+        if self.search([
+                    ('post_move_sequence', '=', self.post_move_sequence.id),
+                    ('id', '!=', self.id),
+                    ]):
+            return False
         return True
 
-    def write(self, ids, vals):
+    @classmethod
+    def write(cls, fiscalyears, vals):
         if vals.get('post_move_sequence'):
-            for fiscalyear in self.browse(ids):
+            for fiscalyear in fiscalyears:
                 if fiscalyear.post_move_sequence and \
                         fiscalyear.post_move_sequence.id != \
                         vals['post_move_sequence']:
-                    self.raise_user_error('change_post_move_sequence')
+                    cls.raise_user_error('change_post_move_sequence')
         vals = vals.copy()
         if 'periods' in vals:
             operator = ['delete', 'unlink_all', 'unlink', 'create', 'write',
                     'add', 'set']
             vals['periods'].sort(
                 lambda x, y: cmp(operator.index(x[0]), operator.index(y[0])))
-        return super(FiscalYear, self).write(ids, vals)
+        super(FiscalYear, cls).write(fiscalyears, vals)
 
-    def delete(self, ids):
-        period_obj = Pool().get('account.period')
+    @classmethod
+    def delete(cls, fiscalyears):
+        Period = Pool().get('account.period')
+        Period.delete([p for f in fiscalyears for p in f.periods])
+        super(FiscalYear, cls).delete(fiscalyears)
 
-        period_ids = []
-        for fiscalyear in self.browse(ids):
-            period_ids.extend([x.id for x in fiscalyear.periods])
-        period_obj.delete(period_ids)
-        return super(FiscalYear, self).delete(ids)
-
+    @classmethod
     @ModelView.button
-    def create_period(self, ids, interval=1):
+    def create_period(cls, fiscalyears, interval=1):
         '''
         Create periods for the fiscal years with month interval
         '''
-        period_obj = Pool().get('account.period')
-        for fiscalyear in self.browse(ids):
+        Period = Pool().get('account.period')
+        for fiscalyear in fiscalyears:
             period_start_date = fiscalyear.start_date
             while period_start_date < fiscalyear.end_date:
                 period_end_date = period_start_date + \
@@ -161,7 +161,7 @@
                 name = datetime_strftime(period_start_date, '%Y-%m')
                 if name != datetime_strftime(period_end_date, '%Y-%m'):
                     name += ' - ' + datetime_strftime(period_end_date, '%Y-%m')
-                period_obj.create({
+                Period.create({
                     'name': name,
                     'start_date': period_start_date,
                     'end_date': period_end_date,
@@ -171,138 +171,132 @@
                     })
                 period_start_date = period_end_date + relativedelta(days=1)
 
+    @classmethod
     @ModelView.button
-    def create_period_3(self, ids):
+    def create_period_3(cls, fiscalyears):
         '''
         Create periods for the fiscal years with 3 months interval
         '''
-        self.create_period(ids, interval=3)
+        cls.create_period(fiscalyears, interval=3)
 
-    def find(self, company_id, date=None, exception=True):
+    @classmethod
+    def find(cls, company_id, date=None, exception=True):
         '''
         Return the fiscal year for the company_id
             at the date or the current date.
         If exception is set the function will raise an exception
             if any fiscal year is found.
         '''
-        date_obj = Pool().get('ir.date')
+        Date = Pool().get('ir.date')
 
         if not date:
-            date = date_obj.today()
-        ids = self.search([
+            date = Date.today()
+        fiscalyears = cls.search([
             ('start_date', '<=', date),
             ('end_date', '>=', date),
             ('company', '=', company_id),
             ], order=[('start_date', 'DESC')], limit=1)
-        if not ids:
+        if not fiscalyears:
             if exception:
-                self.raise_user_error('no_fiscalyear_date')
+                cls.raise_user_error('no_fiscalyear_date')
             else:
                 return None
-        return ids[0]
+        return fiscalyears[0].id
 
-    def _process_account(self, account, fiscalyear):
+    def _process_account(self, account):
         '''
         Process account for a fiscal year closed
+        '''
+        Currency = Pool().get('currency.currency')
+        Deferral = Pool().get('account.account.deferral')
 
-        :param account: a BrowseRecord of the account
-        :param fiscalyear: a BrowseRecord of the fiscal year closed
-        '''
-        currency_obj = Pool().get('currency.currency')
-        deferral_obj = Pool().get('account.account.deferral')
-
-        if account.kind == 'view':
+        if self.kind == 'view':
             return
-        if not account.deferral:
-            if not currency_obj.is_zero(fiscalyear.company.currency,
-                    account.balance):
+        if not self.deferral:
+            if not Currency.is_zero(self.company.currency, account.balance):
                 self.raise_user_error('account_balance_not_zero',
                         error_args=(account.rec_name,))
         else:
-            deferral_obj.create({
+            Deferral.create({
                 'account': account.id,
-                'fiscalyear': fiscalyear.id,
+                'fiscalyear': self.id,
                 'debit': account.debit,
                 'credit': account.credit,
                 })
 
+    @classmethod
     @ModelView.button
-    def close(self, ids):
+    def close(cls, fiscalyears):
         '''
         Close a fiscal year
         '''
-        period_obj = Pool().get('account.period')
-        account_obj = Pool().get('account.account')
+        pool = Pool()
+        Period = pool.get('account.period')
+        Account = pool.get('account.account')
 
-        for fiscalyear in self.browse(ids):
-            if self.search([
+        for fiscalyear in fiscalyears:
+            if cls.search([
                 ('end_date', '<=', fiscalyear.start_date),
                 ('state', '=', 'open'),
                 ('company', '=', fiscalyear.company.id),
                 ]):
-                self.raise_user_error('close_error')
+                cls.raise_user_error('close_error')
 
             #First close the fiscalyear to be sure
             #it will not have new period created between.
-            self.write(fiscalyear.id, {
+            cls.write([fiscalyear], {
                 'state': 'close',
                 })
-            period_ids = period_obj.search([
-                ('fiscalyear', '=', fiscalyear.id),
-                ])
-            period_obj.close(period_ids)
+            periods = Period.search([
+                    ('fiscalyear', '=', fiscalyear.id),
+                    ])
+            Period.close(periods)
 
             with Transaction().set_context(fiscalyear=fiscalyear.id,
                     date=None):
-                account_ids = account_obj.search([
-                    ('company', '=', fiscalyear.company.id),
-                    ])
-                accounts = account_obj.browse(account_ids)
+                accounts = Account.search([
+                        ('company', '=', fiscalyear.company.id),
+                        ])
             for account in accounts:
-                self._process_account(account, fiscalyear)
+                fiscalyear._process_account(account)
 
+    @classmethod
     @ModelView.button
-    def reopen(self, ids):
+    def reopen(cls, fiscalyears):
         '''
         Re-open a fiscal year
         '''
-        deferral_obj = Pool().get('account.account.deferral')
+        Deferral = Pool().get('account.account.deferral')
 
-        for fiscalyear in self.browse(ids):
-            if self.search([
+        for fiscalyear in fiscalyears:
+            if cls.search([
                 ('start_date', '>=', fiscalyear.end_date),
                 ('state', '=', 'close'),
                 ('company', '=', fiscalyear.company.id),
                 ]):
-                self.raise_user_error('reopen_error')
+                cls.raise_user_error('reopen_error')
 
-            deferral_ids = deferral_obj.search([
+            deferrals = Deferral.search([
                 ('fiscalyear', '=', fiscalyear.id),
                 ])
-            deferral_obj.delete(deferral_ids)
+            Deferral.delete(deferrals)
 
-            self.write(fiscalyear.id, {
+            cls.write([fiscalyear], {
                 'state': 'open',
                 })
 
-FiscalYear()
-
 
 class CloseFiscalYearStart(ModelView):
     'Close Fiscal Year'
-    _name = 'account.fiscalyear.close.start'
-    _description = __doc__
+    __name__ = 'account.fiscalyear.close.start'
     close_fiscalyear = fields.Many2One('account.fiscalyear',
             'Fiscal Year to close', required=True,
             domain=[('state', '!=', 'close')])
 
-CloseFiscalYearStart()
-
 
 class CloseFiscalYear(Wizard):
     'Close Fiscal Year'
-    _name = 'account.fiscalyear.close'
-
+    __name__ = 'account.fiscalyear.close'
     start = StateView('account.fiscalyear.close.start',
         'account.fiscalyear_close_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -310,9 +304,7 @@
             ])
     close = StateTransition()
 
-    def transition_close(self, session):
-        fiscalyear_obj = Pool().get('account.fiscalyear')
-        fiscalyear_obj.close([session.start.close_fiscalyear.id])
+    def transition_close(self):
+        Fiscalyear = Pool().get('account.fiscalyear')
+        Fiscalyear.close([self.start.close_fiscalyear])
         return 'end'
-
-CloseFiscalYear()
diff -r f40675df5d4c trytond/modules/account/journal.py
--- a/trytond/modules/account/journal.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/journal.py	Mon Sep 24 20:36:38 2012 +0200
@@ -7,6 +7,9 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['JournalType', 'JournalView', 'JournalViewColumn', 'Journal',
+    'JournalPeriod', 'CloseJournalPeriod', 'ReOpenJournalPeriod']
+
 STATES = {
     'readonly': Eval('state') == 'close',
 }
@@ -18,41 +21,36 @@
 }
 
 
-class Type(ModelSQL, ModelView):
+class JournalType(ModelSQL, ModelView):
     'Journal Type'
-    _name = 'account.journal.type'
-    _description = __doc__
+    __name__ = 'account.journal.type'
     name = fields.Char('Name', size=None, required=True, translate=True)
     code = fields.Char('Code', size=None, required=True)
 
-    def __init__(self):
-        super(Type, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(JournalType, cls).__setup__()
+        cls._sql_constraints += [
             ('code_uniq', 'UNIQUE(code)', 'The code must be unique!'),
-        ]
-        self._order.insert(0, ('code', 'ASC'))
+            ]
+        cls._order.insert(0, ('code', 'ASC'))
 
-Type()
 
-
-class View(ModelSQL, ModelView):
+class JournalView(ModelSQL, ModelView):
     'Journal View'
-    _name = 'account.journal.view'
-    _description = __doc__
+    __name__ = 'account.journal.view'
     name = fields.Char('Name', size=None, required=True)
     columns = fields.One2Many('account.journal.view.column', 'view', 'Columns')
 
-    def __init__(self):
-        super(View, self).__init__()
-        self._order.insert(0, ('name', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(JournalView, cls).__setup__()
+        cls._order.insert(0, ('name', 'ASC'))
 
-View()
 
-
-class Column(ModelSQL, ModelView):
+class JournalViewColumn(ModelSQL, ModelView):
     'Journal View Column'
-    _name = 'account.journal.view.column'
-    _description = __doc__
+    __name__ = 'account.journal.view.column'
     name = fields.Char('Name', size=None, required=True)
     field = fields.Many2One('ir.model.field', 'Field', required=True,
             domain=[('model.model', '=', 'account.move.line')])
@@ -63,33 +61,33 @@
     required = fields.Boolean('Required')
     readonly = fields.Boolean('Readonly')
 
-    def __init__(self):
-        super(Column, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(JournalViewColumn, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(Column, self).init(module_name)
+        super(JournalViewColumn, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_required(self):
+    @staticmethod
+    def default_required():
         return False
 
-    def default_readonly(self):
+    @staticmethod
+    def default_readonly():
         return False
 
-Column()
-
 
 class Journal(ModelSQL, ModelView):
     'Journal'
-    _name = 'account.journal'
-    _description = __doc__
-
+    __name__ = 'account.journal'
     name = fields.Char('Name', size=None, required=True, translate=True)
     code = fields.Char('Code', size=None)
     active = fields.Boolean('Active', select=True)
@@ -126,60 +124,63 @@
                 'invisible': ~Eval('context', {}).get('company', 0),
                 }, depends=['type', 'centralised']))
 
-    def __init__(self):
-        super(Journal, self).__init__()
-        self._order.insert(0, ('name', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(Journal, cls).__setup__()
+        cls._order.insert(0, ('name', 'ASC'))
 
-    def init(self, module_name):
-        super(Journal, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(Journal, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 sequence Many2One change into Property
         if table.column_exist('sequence'):
-            property_obj = Pool().get('ir.property')
-            cursor.execute('SELECT id, sequence FROM "' + self._table + '"')
+            Property = Pool().get('ir.property')
+            cursor.execute('SELECT id, sequence FROM "' + cls._table + '"')
             with Transaction().set_user(0):
                 for journal_id, sequence_id in cursor.fetchall():
-                    property_obj.set('sequence', self._name,
+                    Property.set('sequence', cls._name,
                             journal_id, (sequence_id and
                                 'ir.sequence,' + str(sequence_id) or False))
             table.drop_column('sequence', exception=True)
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_centralised(self):
+    @staticmethod
+    def default_centralised():
         return False
 
-    def default_update_posted(self):
+    @staticmethod
+    def default_update_posted():
         return False
 
-    def default_sequence(self):
+    @staticmethod
+    def default_sequence():
         return None
 
-    def get_types(self):
-        type_obj = Pool().get('account.journal.type')
-        type_ids = type_obj.search([])
-        types = type_obj.browse(type_ids)
+    @staticmethod
+    def get_types():
+        Type = Pool().get('account.journal.type')
+        types = Type.search([])
         return [(x.code, x.name) for x in types]
 
-    def search_rec_name(self, name, clause):
-        ids = self.search([
-            ('code',) + clause[1:],
-            ], limit=1, order=[])
-        if ids:
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        journals = cls.search([
+                ('code',) + clause[1:],
+                ], limit=1, order=[])
+        if journals:
             return [('code',) + clause[1:]]
-        return [(self._rec_name,) + clause[1:]]
+        return [(cls._rec_name,) + clause[1:]]
 
-Journal()
 
-
-class Period(ModelSQL, ModelView):
+class JournalPeriod(ModelSQL, ModelView):
     'Journal - Period'
-    _name = 'account.journal.period'
-    _description = __doc__
-
+    __name__ = 'account.journal.period'
     name = fields.Char('Name', size=None, required=True)
     journal = fields.Many2One('account.journal', 'Journal', required=True,
             ondelete='CASCADE', states=STATES, depends=DEPENDS)
@@ -193,14 +194,15 @@
         ('close', 'Close'),
         ], 'State', readonly=True, required=True)
 
-    def __init__(self):
-        super(Period, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(JournalPeriod, cls).__setup__()
+        cls._sql_constraints += [
             ('journal_period_uniq', 'UNIQUE(journal, period)',
                 'You can only open one journal per period!'),
-        ]
-        self._order.insert(0, ('name', 'ASC'))
-        self._error_messages.update({
+            ]
+        cls._order.insert(0, ('name', 'ASC'))
+        cls._error_messages.update({
             'modify_del_journal_period': 'You can not modify/delete ' \
                     'a journal - period with moves!',
             'create_journal_period': 'You can not create ' \
@@ -209,93 +211,89 @@
                     'a journal - period from a closed period!',
             })
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'open'
 
-    def get_icon(self, ids, name):
-        res = {}
-        for period in self.browse(ids):
-            res[period.id] = _ICONS.get(period.state, '')
-        return res
+    def get_icon(self, name):
+        return _ICONS.get(self.state, '')
 
-    def _check(self, ids):
-        move_obj = Pool().get('account.move')
-        for period in self.browse(ids):
-            move_ids = move_obj.search([
-                ('journal', '=', period.journal.id),
-                ('period', '=', period.period.id),
-                ], limit=1)
-            if move_ids:
-                self.raise_user_error('modify_del_journal_period')
-        return
+    @classmethod
+    def _check(cls, periods):
+        Move = Pool().get('account.move')
+        for period in periods:
+            moves = Move.search([
+                    ('journal', '=', period.journal.id),
+                    ('period', '=', period.period.id),
+                    ], limit=1)
+            if moves:
+                cls.raise_user_error('modify_del_journal_period')
 
-    def create(self, vals):
-        period_obj = Pool().get('account.period')
+    @classmethod
+    def create(cls, vals):
+        Period = Pool().get('account.period')
         if vals.get('period'):
-            period = period_obj.browse(vals['period'])
+            period = Period(vals['period'])
             if period.state == 'close':
-                self.raise_user_error('create_journal_period')
-        return super(Period, self).create(vals)
+                cls.raise_user_error('create_journal_period')
+        return super(JournalPeriod, cls).create(vals)
 
-    def write(self, ids, vals):
+    @classmethod
+    def write(cls, periods, vals):
         if vals != {'state': 'close'} \
                 and vals != {'state': 'open'}:
-            self._check(ids)
+            cls._check(periods)
         if vals.get('state') == 'open':
-            for journal_period in self.browse(ids):
+            for journal_period in periods:
                 if journal_period.period.state == 'close':
-                    self.raise_user_error('open_journal_period')
-        return super(Period, self).write(ids, vals)
+                    cls.raise_user_error('open_journal_period')
+        super(JournalPeriod, cls).write(periods, vals)
 
-    def delete(self, ids):
-        self._check(ids)
-        return super(Period, self).delete(ids)
+    @classmethod
+    def delete(cls, periods):
+        cls._check(periods)
+        super(JournalPeriod, cls).delete(periods)
 
-    def close(self, ids):
+    @classmethod
+    def close(cls, periods):
         '''
         Close journal - period
+        '''
+        cls.write(periods, {
+                'state': 'close',
+                })
 
-        :param ids: the journal - period ids
-        '''
-        self.write(ids, {
-            'state': 'close',
-            })
-
-    def open_(self, ids):
+    @classmethod
+    def open_(cls, periods):
         "Open journal - period"
-        self.write(ids, {
+        cls.write(periods, {
                 'state': 'open',
                 })
 
-Period()
 
-
-class ClosePeriod(Wizard):
+class CloseJournalPeriod(Wizard):
     'Close Journal - Period'
-    _name = 'account.journal.period.close'
+    __name__ = 'account.journal.period.close'
     start_state = 'close'
     close = StateTransition()
 
-    def transition_close(self, session):
-        journal_period_obj = Pool().get('account.journal.period')
-        journal_period_obj.close(Transaction().context['active_ids'])
+    def transition_close(self):
+        JournalPeriod = Pool().get('account.journal.period')
+        JournalPeriod.close(JournalPeriod(Transaction().context['active_ids']))
         return 'end'
 
-ClosePeriod()
 
-
-class ReOpenPeriod(Wizard):
+class ReOpenJournalPeriod(Wizard):
     'Re-Open Journal - Period'
-    _name = 'account.journal.period.reopen'
+    __name__ = 'account.journal.period.reopen'
     start_state = 'reopen'
     reopen = StateTransition()
 
-    def transition_reopen(self, session):
-        journal_period_obj = Pool().get('account.journal.period')
-        journal_period_obj.open_(Transaction().context['active_ids'])
+    def transition_reopen(self):
+        JournalPeriod = Pool().get('account.journal.period')
+        JournalPeriod.open_(JournalPeriod(Transaction().context['active_ids']))
         return 'end'
-
-ReOpenPeriod()
